
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《C++ Concurrency in Action》中文版 / iVAN</title>

    <meta name="description" content="《C++ Concurrency in Action》中文版 2014年马上就到了,借此文感谢各位同学一直以来对并发编程网的支持和厚爱,祝大家新年快乐,并在新的一年里事事马到成功!在新的一年里如果您对并发编程网有什么要求,请只管在本文的回复里告诉我们. 至此新春之际,并发网和人民邮电出版社将在2014年向大家推送&lt;C++ Concurrency in Action&gt;中文版的样章,该书即将登场,而并发编程网让大家先睹为快!本文是第一篇,主要是包含本书的内容介绍,目录和译者介绍.喜欢的话请猛点赞. 内容介绍 本书是一本基于C++11新标准的并发和多 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《C++ Concurrency in Action》中文版</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>2014年马上就到了，借此文感谢各位同学一直以来对并发编程网的支持和厚爱，祝大家新年快乐，并在新的一年里事事马到成功！在新的一年里如果您对并发编程网有什么要求，请只管在本文的回复里告诉我们。</p>
<p>至此新春之际，并发网和<strong>人民邮电出版社</strong>将在2014年向大家推送《C++ Concurrency in Action》中文版的样章，该书即将登场，而并发编程网让大家先睹为快！本文是第一篇，主要是包含本书的内容介绍，目录和译者介绍。喜欢的话请猛点赞。</p>
<h1>内容介绍</h1>
<p>本书是一本基于C++11新标准的并发和多线程编程深度指南。从std::thread、std::mutex、std::future和std::async等基础类的使用，到内存模型和原子操作、基于锁和无锁数据结构的构建，再扩展到并行算法、线程管理，最后还介绍了多线程代码的测试工作。本书的附录部分还对C++11新语言特性中与多线程相关的项目进行了简要的介绍，并提供了C++11线程库的完整参考。</p>
<p>本书适合于需要深入了解C++多线程开发的读者，以及使用C++进行各类软件开发的开发人员、测试人员。对于使用第三方线程库的读者，也可以从本书后面的章节中了解到相关的指引和技巧。同时，本书还可以作为C++11线程库的参考工具书。</p>
<h1>目录</h1>
<p>第1章 你好，C++的并发世界… 1</p>
<p>1.1 什么是并发… 1</p>
<p>1.1.1 计算机系统的并发… 1</p>
<p>1.1.2 并发的方法… 3</p>
<p>1.2 为什么使用并发… 4</p>
<p>1.2.1 因划分重点而使用并发… 5</p>
<p>1.2.2 为了提高性能而使用并发… 5</p>
<p>1.2.3 什么时候不使用并发… 6</p>
<p>1.3 在C++中使用并发和多线程… 7</p>
<p>1.3.1 多线程在C++中的发展历程… 7</p>
<p>1.3.2 新标准对于并发的支持… 8</p>
<p>1.3.3 C++线程库的效率… 8</p>
<p>1.3.4 平台相关的工具… 9</p>
<p>1.4 开始入门… 9</p>
<p>1.4.1 你好，并发世界… 9</p>
<p>1.5 小结… 10</p>
<p>第2章 线程管理… 13</p>
<p>2.1 基本线程管理… 13</p>
<p>2.1.1 启动线程… 13</p>
<p>2.1.2 等待线程完成… 16</p>
<p>2.1.3 在异常环境下的等待… 16</p>
<p>2.1.4 后台运行线程… 18</p>
<p>2.2 传递参数给线程函数… 19</p>
<p>2.3 转让线程的所有权… 21</p>
<p>2.4 在运行时选择线程数… 24</p>
<p>2.5 标识线程… 26</p>
<p>2.6 小结… 28</p>
<p>第3章 在线程间共享数据… 29</p>
<p>3.1 线程之间共享数据的问题… 29</p>
<p>3.1.1 竞争条件… 31</p>
<p>3.1.2 避免有问题的竞争条件… 31</p>
<p>3.2 用互斥元保护共享数据… 32</p>
<p>3.2.1 使用C++中的互斥元… 32</p>
<p>3.2.2 用于保护共享数据的结构化代码… 33</p>
<p>3.2.3 暴露接口中固有的竞争条件… 35</p>
<p>3.2.4 死锁：问题和解决方案… 41</p>
<p>3.2.5 避免死锁的进一步指导… 42</p>
<p>3.2.6 使用std::unique_lock灵活锁定… 47</p>
<p>3.2.7 在作用域之间转移锁的所有权… 48</p>
<p>3.2.8 锁定在适当的粒度… 49</p>
<p>3.3 用于共享数据保护的替代工具… 51</p>
<p>3.3.1 在初始化过程中保护共享数据… 51</p>
<p>3.3.2 保护很少更新的数据结构… 54</p>
<p>3.3.3 递归锁… 56</p>
<p>3.4 小结… 56</p>
<p>第4章 同步并发操作… 59</p>
<p>4.1 等待一个事件或其他条件… 59</p>
<p>4.1.1 使用条件变量的等待条件… 60</p>
<p>4.1.2 使用条件变量建立一个线程安全队列… 62</p>
<p>4.2 使用future来等待一次性事件… 67</p>
<p>4.2.1 从后台任务中返回值… 67</p>
<p>4.2.2 将任务与future相关联… 69</p>
<p>4.2.3 创建(std::)promise. 72</p>
<p>4.2.4 为future保存异常… 73</p>
<p>4.2.5 来自多个线程的等待… 75</p>
<p>4.3 在时间限制内等待… 77</p>
<p>4.3.1 时钟… 77</p>
<p>4.3.2 持续时间… 78</p>
<p>4.3.3 时间点… 79</p>
<p>4.3.4 接受超时的函数… 80</p>
<p>4.4 使用操作同步简化代码… 82</p>
<p>4.4.1 带有future的函数式编程… 82</p>
<p>4.4.2 具有消息传递的同步操作… 85</p>
<p>4.5 小结… 89</p>
<p>第5章 C++内存模型和原子类型上操作… 91</p>
<p>5.1 内存模型基础知识… 91</p>
<p>5.1.1 对象和内存位置… 91</p>
<p>5.1.2 对象，内存位置以及并发… 92</p>
<p>5.1.3 修改指令… 93</p>
<p>5.2 C++中的原子操作及类型… 93</p>
<p>5.2.1 标准原子类型… 94</p>
<p>5.2.2 std::atomic_flag运算… 96</p>
<p>5.2.3 基于std::atomic&lt;bool&gt;的操作… 97</p>
<p>5.2.4 std::atomic&lt;T*&gt;的操作：指针算术运算… 99</p>
<p>5.2.5 标准原子整数类型的操作… 100</p>
<p>5.2.6 std::atomic&lt;&gt;主要类模板… 101</p>
<p>5.2.7 原子操作的自由函数… 102</p>
<p>5.3 同步操作和执行排序… 103</p>
<p>5.3.1 synchronizes-with关系… 105</p>
<p>5.3.2 happens-before关系… 106</p>
<p>5.3.3 原子操作的内存排序… 107</p>
<p>5.3.4 释放序列和synchronize-with. 122</p>
<p>5.3.5 栅栏… 124</p>
<p>5.3.6 使用原子来排序非原子操作… 126</p>
<p>5.4 小结… 128</p>
<p>第6章 设计基于锁的并发数据结构… 129</p>
<p>6.1 为并发性而设计的含义是什么？… 129</p>
<p>6.1.1 为并发性设计数据结构的准则… 130</p>
<p>6.2 基于锁的并发数据结构… 131</p>
<p>6.2.1 使用锁的线程安全栈… 131</p>
<p>6.2.2 使用锁和条件变量的线程安全队列… 133</p>
<p>6.2.3 使用细粒度锁和条件变量的线程安全队列… 137</p>
<p>6.3 设计更为复杂的基于锁的数据结构… 148</p>
<p>6.3.1 编写一个使用锁的线程安全查找表… 148</p>
<p>6.3.2 编写一个使用锁的线程安全链表… 153</p>
<p>6.4 小结… 157</p>
<p>第7章 设计无锁的并发数据结构… 159</p>
<p>7.1 定义和结果… 159</p>
<p>7.1.1 无阻塞数据结构类型… 159</p>
<p>7.1.2 无锁的数据结构… 160</p>
<p>7.1.3 无等待数据结构… 160</p>
<p>7.1.4 无锁数据结构的有利和不利方面… 161</p>
<p>7.2 无锁数据结构的例子… 162</p>
<p>7.2.1 设计不使用锁的线程安全栈… 162</p>
<p>7.2.2 停止这些讨厌的泄漏：在无锁数据结构中管理内存… 166</p>
<p>7.2.3 用风险指针来检查哪些结点不能被回收… 170</p>
<p>7.2.4 使用引用计数侦测结点… 177</p>
<p>7.2.5 在无锁栈上应用内存模型… 181</p>
<p>7.2.6 写一个无锁的线程安全队列… 185</p>
<p>7.3 编写无锁数据结构的准则… 197</p>
<p>7.3.1 准则：使用std::memory_order_seq_cst做原型设计… 197</p>
<p>7.3.2 准则：使用无锁内存回收利用策略… 197</p>
<p>7.3.3 准则：当心ABA问题… 198</p>
<p>7.3.4 准则：识别忙则等待的循环以及帮助别的线程… 198</p>
<p>7.4 小结… 198</p>
<p>第8章 设计并行代码… 201</p>
<p>8.1 线程间划分工作的方法… 201</p>
<p>8.1.1 处理开始前在线程间划分数据… 202</p>
<p>8.1.2 递归地划分数据… 203</p>
<p>8.1.3 通过任务类型划分数据… 206</p>
<p>8.2 影响并发程序性能的因素… 208</p>
<p>8.2.1 有多少个处理器… 208</p>
<p>8.2.2 数据竞争和缓存的乒乓效应… 209</p>
<p>8.2.3 伪共享… 211</p>
<p>8.2.4 数据应该多紧密？… 211</p>
<p>8.2.5 过度订阅和过多的任务切换… 212</p>
<p>8.3 为多线程性能设计数据结构… 212</p>
<p>8.3.1 为复杂操作划分数组元素… 212</p>
<p>8.3.2 其它数据结构中的数据读取方式… 214</p>
<p>8.4 设计并发性时需要考虑的别的方面… 215</p>
<p>8.4.1 并行算法中的异常安全… 215</p>
<p>8.4.2 可扩展性和阿姆达尔定律… 222</p>
<p>8.4.3 用多线程隐藏等待时间… 223</p>
<p>8.4.4 提高并发的响应性… 223</p>
<p>8.5 在实际中设计并发代码… 225</p>
<p>8.5.1 std::for_each的并行实现… 226</p>
<p>8.5.2 std::find的并行实现… 228</p>
<p>8.5.3 std::partial_sum的并行实现… 232</p>
<p>8.6 总结… 241</p>
<p>第9章 高级线程管理… 243</p>
<p>9.1 线程池… 243</p>
<p>9.1.1 最简单的线程池实现… 244</p>
<p>9.1.2 等待任务的完成… 246</p>
<p>9.1.3 等待其他任务完成的任务… 249</p>
<p>9.1.4 避免工作队列的竞争… 252</p>
<p>9.1.5 任务偷取… 253</p>
<p>9.2 中断线程… 258</p>
<p>9.2.1 启动和中断另外一个线程… 258</p>
<p>9.2.2 检测一个线程是否被中断… 260</p>
<p>9.2.3 中断一个条件变量等待… 260</p>
<p>9.2.4 中断一个std::condition_variable_any变量… 263</p>
<p>9.2.5 中断其他阻塞调用… 265</p>
<p>9.2.6 处理中断… 266</p>
<p>9.2.7 在应用中中断后台任务… 266</p>
<p>9.3 总结… 268</p>
<p>第10章 多线程应用的测试和调试… 269</p>
<p>10.1 与并发相关的错误类型… 269</p>
<p>10.1.1 不必要的阻塞… 269</p>
<p>10.2 定位并发相关的错误的测试和调试技巧… 271</p>
<p>10.2.1 检阅代码定位潜在错误… 271</p>
<p>10.2.2 通过测试定位并行相关的错误… 272</p>
<p>10.2.3 易测性设计… 274</p>
<p>10.2.4 多线程测试技术… 275</p>
<p>10.2.5 构建多线程的测试代码… 277</p>
<p>10.2.6 测试多线程代码的性能… 279</p>
<p>10.3 总结… 280</p>
<p>附录A C++11部分语言特性简明参考… 281</p>
<p>A.1 右值引用… 281</p>
<p>A.1.1 移动语义… 282</p>
<p>A.1.2 右值引用与函数模版… 284</p>
<p>A.2 deleted函数… 284</p>
<p>A.3 defaulted函数… 286</p>
<p>A.4 constexpr函数… 289</p>
<p>A.4.1 constexpr与用户定义类型… 290</p>
<p>A.4.2 constexpr对象… 293</p>
<p>A.4.3 constexpr函数要求… 293</p>
<p>A.4.4 constexpr与模板… 294</p>
<p>A.5 lambda函数… 294</p>
<p>A.5.1 引用局部变量的lambda函数… 296</p>
<p>A.6 可变参数模板… 298</p>
<p>A.6.1 展开参数包… 299</p>
<p>A.7 自动推断变量的类型… 301</p>
<p>A.8 线程局部变量… 302</p>
<p>A.9 小结… 303</p>
<p>附录B 并发类库简要对比… 305</p>
<p>附录C 消息传递框架与完整的ATM示例… 307</p>
<p>附录D C++线程类库参考… 326</p>
<p>D.1 &lt;chrono&gt;头文件… 326</p>
<p>D.1.1 std::chrono::duration类模板… 326</p>
<p>D.1.2 std::chrono::time_point类模板… 336</p>
<p>D.1.3 std::chrono::system_clock类… 339</p>
<p>D.1.4 std::chrono::steady_clock类… 341</p>
<p>D.1.5 std::chrono::high_resolution_clock typedef 342</p>
<p>D.2 &lt;condition_variable&gt;头文件… 343</p>
<p>D.2.1 std::condition_variable类… 343</p>
<p>D.2.2 std::condition_variable_any类… 351</p>
<p>D.3 &lt;atomic&gt;头文件… 359</p>
<p>D.3.1 std::atomic_xxx typedef 361</p>
<p>D.3.2 ATOMIC_xxx_LOCK_FREE宏… 361</p>
<p>D.3.3 ATOMIC_VAR_INIT宏… 362</p>
<p>D.3.4 std::memory_order枚举… 362</p>
<p>D.3.5 std::atomic_thread_fence函数… 363</p>
<p>D.3.6 std::atomic_signal_fence函数… 363</p>
<p>D.3.7 std::atomic_flag类… 364</p>
<p>D.3.8 std::atomic类模板… 367</p>
<p>D.3.9 std::atomic模板的特化… 378</p>
<p>D.3.10 std::atomic&lt;integral-type&gt;特化… 379</p>
<p>D.3.11 std::atomic&lt;T*&gt;偏特化… 392</p>
<p>D.4 &lt;future&gt;头文件… 398</p>
<p>D.4.1 std::future类模板… 399</p>
<p>D.4.2 std::shared_future类模板… 405</p>
<p>D.4.3 std::packaged_task类模板… 410</p>
<p>D.4.4 std::promise类模板… 416</p>
<p>D.4.5 std::async函数模板… 422</p>
<p>D.5 &lt;mutex&gt;头文件… 423</p>
<p>D.5.1 std::mutex类… 424</p>
<p>D.5.2 std::recursive_mutex类… 426</p>
<p>D.5.3 std::timed_mutex类… 429</p>
<p>D.5.4 std::recursive_timed_mutex类… 433</p>
<p>D.5.5 std::lock_guard类模板… 438</p>
<p>D.5.6 std::unique_lock类模板… 439</p>
<p>D.5.7 std::lock函数模板… 450</p>
<p>D.5.8 std::try_lock函数模板… 450</p>
<p>D.5.9 std::once_flag类… 451</p>
<p>D.5.10 std::call_once函数模板… 451</p>
<p>D.6 &lt;ratio&gt;头文件… 452</p>
<p>D.6.1 std::ratio类模板… 453</p>
<p>D.6.2 std::ratio_add模板别名… 454</p>
<p>D.6.3 std::ratio_subtract模板别名… 455</p>
<p>D.6.4 std::ratio_multiply模板别名… 455</p>
<p>D.6.5 std::ratio_divide模板别名… 456</p>
<p>D.6.6 std::ratio_equal类模板… 456</p>
<p>D.6.7 std::ratio_not_equal类模板… 457</p>
<p>D.6.8 std::ratio_less类模板… 457</p>
<p>D.6.9 std::ratio_greater类模板… 458</p>
<p>D.6.10 std::ratio_less_equal类模板… 458</p>
<p>D.6.11 std::ratio_greater_equal类模板… 459</p>
<p>D.7 &lt;thread&gt;头文件… 459</p>
<p>D.7.1 std::thread类… 459</p>
<p>D.7.2 this_thread命名空间… 469</p>
<p>资源… 471</p>
<p>印刷资源… 471</p>
<p>在线资源… 471</p>
<h1>译者简介</h1>
<ul>
<li>周全，软件工程师，毕业于中国科学技术大学信息学院，现任职于中国人民银行合肥中心支行科技处。从事.NET开发多年，有较为丰富的系统集成和运维经验，对虚拟化也有较深入的研究。可以通过email: spadeq@live.com与他联系。</li>
<li>宋真真，网络工程师，2008年毕业于合肥工业大学计算机与信息学院，现任职于中国人民银行合肥中心支行科技处，参与软件开发、项目管理等工作，爱好数据库、编程等研究。可以通过email: hfut_szz@sina.com与她联系。</li>
<li>梁娟娟，2010年毕业于中国科学技术大学信息技术学院，现就职于中国人民银行合肥中心支行。</li>
<li> 许敏，软件工程师，2005年获得软件测试工程师证书。现任职于中国人民银行合肥中心支行科技处，负责项目管理工作。可以通过Email: xu_min@sina.com与她联系。</li>
</ul>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 20:15:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《C++ Concurrency in Action》中文版的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2pLaALz.html" rel="bookmark">《Storm入门》中文版</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文翻译自&lt;Getting Started With Storm&gt;译者:吴京润    编辑:郭蕾 方腾飞 本书的译文仅限于学习和研究之用,没有原作者和译者的授权不能用于商业用途. 译者序 Storm入门终于翻译完了.首先感谢并发编程网同意本人在网站上首发本书译文,同时还要感谢并发编程网的各位大牛们的耐心帮助.这是本人翻译的第一本书,其中必有各种不足请诸位读者朋友不吝斧正. 译完此书之后,我已经忘记了是如何知道的Storm这个工具了.本人读过的所有技术书籍大部分都是在地铁上完成的,现在已经成了习			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYNlD6p.html" rel="bookmark">Storm入门之第8章事务性拓扑</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Storm入门之第8章事务性拓扑 本文翻译自&lt;Getting Started With Storm&gt;译者:吴京润    编辑:郭蕾 方腾飞 正如书中之前所提到的,使用Storm编程,可以通过调用ack和fail方法来确保一条消息的处理成功或失败.不过当元组被重发时,会发生什么呢?你又该如何砍不会重复计算?   Storm0.7.0实现了一个新特性--事务性拓扑,这一特性使消息在语义上确保你可以安全的方式重发消息,并保证它们只会被处理一次.在不支持事务性拓扑的情况下,你无法在准确性,可扩展性,以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqD2Rab.html" rel="bookmark">MyEclipse Hibernate 快速入门中文版与Hibernate的相关配置属性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MyEclipse Hibernate 快速入门中文版的HTML完整版本下载地址:  http://beansoft.java-cn.org/download/MyEclipse_Hibernate_Quickstart_zh_CN.zip 719KB Hibernate配置属性 属性名 用途 hibernate.dialect Hibernate方言(Dialect)的类名 - 可以让Hibernate使用某些特定的数据库平台的特性 取值. full.classname.of.Dialect			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmGkE5b.html" rel="bookmark">Storm入门之附录C</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文翻译自&lt;Getting Started With Storm&gt;译者:吴京润    编辑:郭蕾 方腾飞 安装实际的例子 译者注:有些软件的最新版本已有变化,译文不会完全按照原文翻译,而是列出当前最新版本的软件. 首先,从下述GitHub的URL克隆这个例子: 1 &gt; git clone git://github.com/storm-book/examples-ch06-real-life-app.git src/main 包含拓扑的源码 src/test 包含拓扑的测试用例 webap			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBZmmJb.html" rel="bookmark">Storm入门 第二章准备开始</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文翻译自&lt;Getting Started With Storm&gt;  译者:吴京润   编辑:方腾飞 准备开始 在本章,我们要创建一个Storm工程和我们的第一个Storm拓扑结构. NOTE: 下面假设你的JRE版本在1.6以上.我们推荐Oracle提供的JRE.你可以到http://www.java .com/downloads/下载. 操作模式 开始之前,有必要了解一下Storm的操作模式.有下面两种方式. 本地模式 在本地模式下,Storm拓扑结构运行在本地计算机的单一JVM进程上.这			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6NBZNM.html" rel="bookmark">Storm入门之第三章拓扑</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文翻译自&lt;Getting Started With Storm&gt;  译者:吴京润   编辑:方腾飞 在这一章,你将学到如何在同一个Storm拓扑结构内的不同组件之间传递元组,以及如何向一个运行中的Storm集群发布一个拓扑. 数据流组 设计一个拓扑时,你要做的最重要的事情之一就是定义如何在各组件之间交换数据(数据流是如何被bolts消费的).一个数据流组指定了每个bolt会消费哪些数据流,以及如何消费它们. NOTE:一个节点能够发布一个以上的数据流,一个数据流组允许我们选择接收哪个. 数据			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDWgqWp.html" rel="bookmark">Storm入门之第四章Spouts</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文翻译自&lt;Getting Started With Storm&gt;  译者:吴京润   编辑:方腾飞 你将在本章了解到spout作为拓扑入口和它的容错机制相关的最常见的设计策略. 可靠的消息 VS 不可靠的消息 在设计拓扑结构时,始终在头脑中记着的一件重要事情就是消息的可靠性.当有无法处理的消息时,你就要决定该怎么办,以及作为一个整体的拓扑结构该做些什么.举个例子,在处理银行存款时,不要丢失任何事务报文就是很重要的事情.但是如果你要统计分析数以百万的tweeter消息,即使有一条丢失了,仍然可			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MA7KJAz.html" rel="bookmark">Storm入门之附录A</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文翻译自&lt;Getting Started With Storm&gt;译者:吴京润    编辑:郭蕾 方腾飞 安装Storm客户端 Storm客户端能让我们使用命令管理集群中的拓扑.按照以下步骤安装Storm客户端: 从Storm站点下载最新的稳定版本(https://github.com/nathanmarz/storm/downloads)当前最新版本是storm-0.8.1.(译者注:原文是storm-0.6.2,不过翻译的时候已经是storm-0.8.1了) 把下载的文件解压缩到/usr/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm6kxBz.html" rel="bookmark">Storm入门之附录B</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文翻译自&lt;Getting Started With Storm&gt;译者:吴京润    编辑:郭蕾 方腾飞 安装Storm集群 译者注:本附录的内容已经有些陈旧了.最新的Storm已不再必须依赖ZeroMQ,各种依赖的库和软件也已经有更新的版本. 有以下两种方式创建Storm集群: 使用Storm部署在亚马逊EC2上面创建一个集群,就像你在第6章看到的. 手工安装(详见本附录) 要手工安装Storm,需要先安装以下软件 Zookeeper集群(安装方法详见管理向导) Java6.0 Python			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdEknmz.html" rel="bookmark">Storm入门之第一章</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原书下载地址 译者:吴京润   编辑:方腾飞 译者注:本文翻译自&lt;Getting Started With Storm&gt;,本书中所有Storm相关术语都用斜体英文表示. 这些术语的字面意义翻译如下,由于这个工具的名字叫Storm,这些术语一律按照气象名词解释 spout 龙卷,读取原始数据为bolt提供数据 bolt 雷电,从spout或其它bolt接收数据,并处理数据,处理结果可作为其它bolt的数据源或最终结果 nimbus 雨云,主节点的守护进程,负责为工作节点分发任务. 下面的术语跟气			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjv6mb.html" rel="bookmark" class="title">初学jsp心得&lpar;一&rpar;</a>
					<div>
						js|初学|心得 废话不多说! 测试环境为 jdk1.2.2  jswdk-1.0  winnt4.0中文版. 1.java是大小写敏感的,用过其他编程语言的人最容易犯这个错误,尤其是刚上手的时候.我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPdDQM.html" rel="bookmark" class="title">算法练习：最长平台问题</a>
					<div>
						内容:一直一个已经从小到大排序的数组,这个数组中的一个平台就是连续的一串相同的元素,并且这个元素不能再延伸. 例如,在1,2,2,3,3,3,4,5,5,6中1,2,2,3,3,3,4,5,5,6都是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNK68b.html" rel="bookmark" class="title">oracle中创建触发器的语法</a>
					<div>
						创建触发器 创建触发器的一般语法是: CREATE [OR REPLACE] TRIGGER trigger_name {BEFORE | AFTER } {INSERT | DELETE | UPD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5A0DRp.html" rel="bookmark" class="title">win7系统使用QQ管家解决软件运行错误的问题</a>
					<div>
						  win7系统使用QQ管家解决软件运行错误的问题 1.打开QQ电脑管家-工具箱; 2.然后点击 电脑诊所; 3.进入之后点击 软件硬件下方 丢失dll文件; 4.然后点击第一个 丢失d3dx**.d ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oZDAb.html" rel="bookmark" class="title">PS制作漂亮的光晕背景界面</a>
					<div>
						PS制作漂亮的光晕背景界面         注:更多请关注photoshop教程栏目,三联PS教程群:181754111欢迎你的加入 分类: PS入门教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6BKmb.html" rel="bookmark" class="title">win8无法进入休眠状态并提示&OpenCurlyDoubleQuote;不支持该请求&rdquo;的问题原因和解决方法</a>
					<div>
						  windows系统休眠通常是指让系统正在打开的窗口存储到硬盘中,使计算机出现关闭状态,当用户再次运行系统时,将被还原为上次操作窗口状态,不过在win8系统下,有部分用户执行休眠命令时,却被系统提示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5o81Bb.html" rel="bookmark" class="title">160WiFi完美支持雷凌无线网卡下的XP系统</a>
					<div>
						160wifi自此发布以来,一直受到众多用户的热捧.160WiFi能够完美支持WIN7/WIN8/WIN8.1系统的电脑,但是对于XP系统下的WiFi共享,之前只支持一台XP系统的电脑只能连接一台终端 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNVRZM.html" rel="bookmark" class="title">easyrecovery怎么用？</a>
					<div>
						  1.软件打开后我们选择数据恢复-格式化恢复; 2.弹出目的地警告:恢复的话最好要选择和被恢复磁盘不同的分区或者移动磁盘,如果有多个磁盘的话可以是其他磁盘; 3.接下来我们选择一个需要恢复的分区,设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkRkab.html" rel="bookmark" class="title">新浪微博粉丝列表页的粉丝如何排序&quest;</a>
					<div>
						粉丝列表页面的粉丝是根据粉丝关注您的时间先后顺序进行排序的,粉丝顺序无法更改. 通过粉丝列表页可以查看粉丝与您的关系,和对方关注您的方式.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGPRAp.html" rel="bookmark" class="title">嫌弃电脑网速太慢？教你如何清洗</a>
					<div>
						你必须学会清洗电脑-提网速     一.每天关机前清洗 1.双击&quot;我的电脑&quot; 2.右键点C盘 3.点&quot;属性&quot; 4.点&quot;磁盘清理&quot; 5.点&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYGrOM.html" rel="bookmark" class="title">linux-初学Linux，只能ping本机，ping不通网关和外网。。怎么解决？、大神们帮帮忙。。。</a>
					<div>
						问题描述 初学Linux,只能ping本机,ping不通网关和外网..怎么解决?.大神们帮帮忙... 解决方案 服务器分配给你的233.3地址?还是自己配置的.用dhcp动态分配呢. 解决方案二: 本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrrOVM.html" rel="bookmark" class="title">消息总线授权设计</a>
					<div>
						我曾在之前的一篇文章中对比过消息队列跟消息总线.它们其中的一个不同点就是:消息总线更关注通信安全,消息总线可以管控通信双方,对通信的管控是建立在授权的基础上.因此授权模型的设计是消息总线必须考虑的问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVmr3b.html" rel="bookmark" class="title">AngularJS中使用HTML5摄像头拍照</a>
					<div>
						1. 项目背景 公司开发一个网站,在做用户头像修改的时候领导提到增加一个由摄像头拍照实现修改头像的功能.因为我们网站是基于Html5进行开发,所以就直接采用H5来实现拍照.起初觉得这个功能很简单,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QZg6p.html" rel="bookmark" class="title">camera-在取消拍照的情况下如何返回到先前的画面？</a>
					<div>
						问题描述 在取消拍照的情况下如何返回到先前的画面? 我使用一个 intent 去调用 camera 程序可以得到捕获的图像.但是如果图像没有捕获到(取消按钮按下的情况下),我想马上返回到调用 came ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmjJaz.html" rel="bookmark" class="title">Android 中文 API &lpar;100&rpar; &mdash;&mdash; ScrollView</a>
					<div>
						前言 春节即至,谨代表Android中文翻译组全体同仁祝大家身体健康,工作顺利!从第一篇译稿2010年8月27发布至今天2011年1月27整5个月,共发布100篇译文,3个合集,在新的一年里,翻译组仍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwx49Eb.html" rel="bookmark" class="title">&lbrack;翻译&rsqb; ios-image-filters</a>
					<div>
						ios-image-filters https://github.com/esilverberg/ios-image-filters photoshop-style filter interface  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDW9Dvp.html" rel="bookmark" class="title">淘米网登陆纽交所挂牌交易</a>
					<div>
						本报讯 (记者李斌)中国儿童娱乐网络社区淘米网的上市申请获得最后批准,已于昨晚正式登陆美国纽约证券交易所,交易代码为&quot;TAOM&quot;.据悉,淘米确定的IPO(首次公开招股)发行价为9美 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoR5Rb.html" rel="bookmark" class="title">提问如何用vb&period;net实现将excel文件导入oracle数据库</a>
					<div>
						问题描述 提问如何用vb.net实现将excel文件导入oracle数据库,或者是csv文件也可以需要新建一个表,将文本中的内容导入这个表,需要有框架,大体就是选择一个文件,导入就可以 解决方案 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6JeBz.html" rel="bookmark" class="title">mysql-ssh 关于数据库读取方式及内容处理的相关问题，求解答！</a>
					<div>
						问题描述 ssh 关于数据库读取方式及内容处理的相关问题,求解答! 本人刚自学完ssh,现在想写一个网站,有几个问题想找人解答. 问题一:我想在主页上显示新闻,目前只能通过如下方法读取数据库内容. & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAXZRM.html" rel="bookmark" class="title">matlab-MATLAB中的直方图均衡函数histeq在opencv中实现碰到的问题</a>
					<div>
						问题描述 MATLAB中的直方图均衡函数histeq在opencv中实现碰到的问题 有没有人知道 MATALB中的直方图均衡函数histeq和opencv中的cvEqualizeHist()函数的区别 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Yaq4M.html" rel="bookmark" class="title">Scribus 1&period;4&period;1发布 桌面页面设计工具</a>
					<div>
						Scribus 是一款专业的桌面页面http://www.aliyun.com/zixun/aggregation/6993.html&quot;&gt;设计工具,支持Linux/UNIX.Mac O ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKAw2z.html" rel="bookmark" class="title">java动态代理实现Proxy和InvocationHandler cglib</a>
					<div>
						概念: 静态代理:由程序员创建或特定工具自动生成源代码,再对其编译.在程序运行前,代理类的.class文件就已经存在了. 动态代理:在程序运行时,运用反射机制动态创建而成. JDK的动态代理用起来非常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLGk5p.html" rel="bookmark" class="title">总结网络分销商常用的推广方法</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 目前网络分销商常用的推广方法基本就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYe2dp.html" rel="bookmark" class="title">iPhone&sol;ipad连接网络后接收QQ消息但不能上网问题解决办法</a>
					<div>
						1.不能上网看看电脑是不是能不能上网了,这个可以检查一下你的路由器哦. 2.如果只是iPhone不能上网我们可以重新连接一下wifi网络试一下 3.重新启动你的iPhone,大部分小问题,都可以尝试关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZVYOM.html" rel="bookmark" class="title">Expression Design 4 - Chapter 1 入门界面简介</a>
					<div>
						Expression Design 是Expression系列里面的一员,更是Blend跟Web的好帮手 而在这章教学,我将会介绍Expression Design 4的基本界面   打开Expres ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKY17np.html" rel="bookmark" class="title">规划网站-一个人开发一个网站，想整体规划下，在动手开发，用什么技术可以整体规划</a>
					<div>
						问题描述 一个人开发一个网站,想整体规划下,在动手开发,用什么技术可以整体规划 如果不规划,容易到后面开发会推翻或修改前面的开发(代码) 经常返工! 解决方案 uml,数据建模,画流程图,前期越详细, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo7PwM.html" rel="bookmark" class="title">2014年的餐饮O2O呈现了哪些特点&quest;</a>
					<div>
						然而,纵观2014的餐饮O2O市场,虽然大动作迭起,但是总体看来还是各家修炼内功.布局市场的一年.在2014年磨刀霍霍的准备下,2015年必将会是鲜血飞溅. 2014年的餐饮O2O呈现了哪些特点,20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgQqaM.html" rel="bookmark" class="title">寻找精通&period;NET Memory Profiler的高人给小弟来指点迷津</a>
					<div>
						问题描述 有没有哪位精通.NETMemoryProfiler的高人能给小弟指点一二,最近在使用这个工具检测内存泄漏,但是这个工具太复杂了,搞不懂啊帮忙解释下下面这个图说明什么? 解决方案 本帖最后由  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvn0yNM.html" rel="bookmark" class="title">台积电年底以前量产10纳米芯片 领先英特尔近一年</a>
					<div>
						北京时间10月1日消息,据外媒报道,苹果芯片代工商台积电已经对公司未来的路线图给出了提示,该公司将在今年年底以前开始量产10纳米芯片,领先英特尔近一年时间. 在台湾北部新竹市举行的技术研讨会上,台积电 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOla2b.html" rel="bookmark" class="title">急，关于CH372的程序</a>
					<div>
						问题描述 请问用C#如何做CH372的调试程序,急~~~~~~~~~~~~我QQ275896387,谢谢高手加我 解决方案 解决方案二:捡个沙发坐坐解决方案三:该回复于2008-03-19 08:35 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.040 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
